////////////////////////////////////////////////////////////////
//
//       Filename:  FrameBase.go
//
//        Version:  1.0
//        Created:  2022年11月17日 10时35分41秒
//       Revision:  none
//       Compiler:  go
//
//         Author:  alpha
//   Organization:  alpha
//       Contacts:  chenxinquan@kylinos.com
//
////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
// Description:
////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
// Log:
////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
// Todo:
//
////////////////////////////////////////////////////////////////

package gconsole

import (
    "github.com/jesseduffield/gocui"
)

type
FrameBase interface {
    Setup()
    Quit(g *gocui.Gui, v*gocui.View)
    KeyBinding(g *gocui.Gui)

    ///////////////////////////////
    // navigation
    NextView(g *gocui.Gui, v *gocui.View)
    PreView(g *gocui.Gui, v *gocui.View)
    CursorDown(g *gocui.Gui, v *gocui.View)
    CursorUp(g *gocui.Gui, v *gocui.View)
    CursorPageDown(g *gocui.Gui, v *gocui.View)
    CursorPageUp(g *gocui.Gui, v *gocui.View)

}
