package genmai

import (
    "time"
)

type
ReportBaseLine struct {
    ReportCommon
}
type
VulnInfoBaseLine struct {
    VulnInfoCommon
}

func
GetTemplateReportBaseLine() (*ReportBaseLine) {
    var expvuls []VulnInfoCommon
    expvuls = append(expvuls, GetTemplateVulnInfoBaseLine().VulnInfoCommon)
    /* */
    var expip4addr []string
    expip4addr = append(expip4addr, "0.0.0.0")
    var expip6addr []string
    expip6addr = append(expip6addr, "0.0.0.0")
    /* */
    return &ReportBaseLine {
                ReportCommon {
                    RCServerUUID:       "1234-5678-1234-5678",
                    RCServerName:       "aServer-BaseLine",
                    RCFamily:           "RCFamily",
                    RCRelease:          "RCRelease",
                    RCContainer:        "RCContainer",
                    /* */
                    RCExploredTimeAt:   time.Now(),
                    RCExecPocNums:      0,
                    RCRepairedNums:     0,
                    RCNotFixedNums:     0,
                    RCNotExecPocNums:   0,
                    RCExploredMode:     "RCExploredMode",
                    RCExploredVersion:  "RCExploredVersion",
                    RCExploredRevision: "RCExploredRevision",
                    RCExploredBy:       "RCExploredBy",
                    RCExploredVia:      "RCExploredVia",
                    RCExploredIPv4Addrs:expip4addr,
                    RCExploredIPv6Addrs:expip6addr,
                    /* */
                    RCReportedAt:       time.Now(),
                    RCReportedVersion:  "RCReportedVersion",
                    RCReportedBy:       "RCReportedBy",
                    /* */
                    RCErrors:           "RCErrors",
                    RCWarnings:         "RCWarnings",

                    RCExploredVulns:    expvuls,
                    RCReunningKernelInfo:ReportKernelInfo {
                                            "0.0",
                                            "0.0",
                                            false,
                                        },
                    RCPackages:         "RCPackages",      // TBD: type
                    RCSrcPackages:      "RCSrcPackages",      // TBD: type
                    RCOptional:         "RCOptional",      // TBD: type
                },
            }
}

func
GetTemplateVulnInfoBaseLine() VulnInfoBaseLine {
    return VulnInfoBaseLine {
                VulnInfoCommon {
                    VICFormatVer:       1,
                    VICId:              "VICId",
                    VICBelong:          "VICBelong",
                    VICPocHazardLevel:  "VICPocHazardLevel",
                    VICSource:          "VICSource",
                },
            }
}

////////////////////////////////////////////////////////////////
// ReportBase methods
func
(rk *ReportBaseLine)GetReportCommon() ReportCommon {
    return rk.ReportCommon
}