import openpyxl
import mysql.connector

# 读取XLSX文件
workbook = openpyxl.load_workbook('../../../data/static/info.xlsx')
sheet = workbook.get_sheet_by_name('type')
# sheet = workbook.active

# 连接到MySQL数据库
conn = mysql.connector.connect(
    host='localhost',
    user='song',
    password='sbcj1999',
    database='genmai'
)
cursor = conn.cursor()
# 遍历XLSX文件中的行，并生成SQL语句
for row in sheet.iter_rows(values_only=True):
    # 假设XLSX文件的列顺序与MySQL表的列顺序一致
    sql = "INSERT INTO package_info (header, package_name) VALUES (%s, %s)"
    values = (row[0], row[1])
    
    # 执行SQL语句
    cursor.execute(sql, values)

# 提交事务并关闭连接
conn.commit()
cursor.close()
conn.close()